/*************************************************************************
** interpcom-2.4     (command interpreter)                               **
** int_def.c      Command interpreter                                    **
**                                                                       **
** Copyright (C) 2001  Jean-Marc Drezet                                  **
**                                                                       **
**  This library is free software; you can redistribute it and/or        **
**  modify it under the terms of the GNU Library General Public          **
**  License as published by the Free Software Foundation; either         **
**  version 2 of the License, or (at your option) any later version.     **
**                                                                       **
**  This library is distributed in the hope that it will be useful,      **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
**  Library General Public License for more details.                     **
**                                                                       **
**  You should have received a copy of the GNU Library General Public    **
**  License along with this library; if not, write to the Free           **
**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
**                                                                       **
** Please mail any bug reports/fixes/enhancements to me at:              **
**      drezet@math.jussieu.fr                                           **
** or                                                                    **
**      Jean-Marc Drezet                                                 **
**      Institut de Mathematiques                                        **
**      UMR 7586 du CNRS                                                 **
**      173, rue du Chevaleret                                           **
**      75013 Paris                                                      **
**      France                                                           **
**                                                                       **
 *************************************************************************/

#include "interp.h"





/*-------------------------------------------------------------------------
    Declaration of the global variables used by the command interpreter
    (see interp.h)
-------------------------------------------------------------------------*/

#ifdef _HAVE_THREADS
pthread_mutex_t     mutex_ev,
                    mutex_obj,
                    mutex_thread,
                    mutex_string,
                    mutex_cond,
                    mutex_file,
                    mutex_quest;
#endif

int                 _NBFONC,
                    _NBFONC_C,
                   *_NBFONC_Gen,
                    NB_expr_eval,
                    __n_max_threads,
                    num_thread_run,
                    n_subst_pat,
                    __max_subst_pat,
                    __nbcom,
                    __nblignes,
                    __com_max,
                    __greet_max,
                    __mess_max,
                    __nss,
                    __nmode_fonc,
                    __maxvoice,
                    __nbcond,
                    __nbtypmax,
                    __nbstrucmax,
                    __nbargmax,
                    __nblabelmax,
                    __max_quest,
                    __n_com_prec,
                    __max_Env_st,
                    __n_expr_eval,
                    ind_x_mode,
                    ind_x_func,
                    ind_x_param,
                    ind_x_rep,
                    ind_run,
                    i_func_ind,
                    Init_File_Line,
                    i_greet,
                   *nb_label,
                   *tr_label,
                  **num_label,
                  **Argc_com,
                  **Is_subst_ligne,
                 ***Is_subst_arg,
                   *Is_Del_prog,
                   *Is_visible_prog,
                   *len_n,
                   *sil_com,
                  **mode_com_int,
                  **mode_com_str,
                  **mode_com_obj,
                   *nb_par,
                    nb_com,
                   *nb_lignes,
                    nb_mode_fonc,
                    nb_commandes,
                    i_message,
                  **mode_com,
                   *par_com,
                   *deb_nom,
                   *fin_nom,
                    i_init_interp,
                    sil_init_interp,
                    argc_init_interp,
                    ind_greet_x,
                    func_init,
                    n_cond,
                   *s_cond,
                   *sS_cmpt,
                   *sS_i_o,
                    nb_typ,
                   *Obj_alias,
                    nb_struc,
                    ind_monfile_color;

char              **mess,
                  **prompt_mode,
                  **greet,
                  **names,
                  **nom_com,
                 ***ligne_com,
                ****Argv_com,
                   *argv_init_interp_b[21],
                  **argv_init_interp,
                  **sS_nom,
                  **ques,
                  **Env_string,
                  **Env_string2,
                    command_rep[80],
                    data_rep[80],
                    data_rep2[80],
                    result_rep[80],
                   *User_Init_File,
                   *col_prompt,
                   *col_mess,
                   *col_echo,
                   *col_prog,
                   *end_col_prompt,
                   *end_col_mess;

struc_typ          *Struc_typ;

strucb            **Struc;

XVARIABLE           VArs_global[MAXXVARS];

XVARIABLE_C         VArs_global_C[MAXXVARS];

EXPREVAL_GEN       *Expreval_ops;

Vars_Gen          **VArs_global_Gen;

flow_data          *flow_I;

subst_delim        *Subst_Delim;

subst_pat          *Subst_Pat;

pfi                *procw;

pfi_get            _interp_fgets;

v_c                *v_cond;

FILE              **sS;

obj_typ            *Obj_typ;

obj               **Obj;
/*-----------------------------------------------------------------------*/

double
_I_sin(double *x)
{
    return sin(*x);
}

double
_I_cos(double *x)
{
    return cos(*x);
}

double
_I_tan(double *x)
{
    return tan(*x);
}

double
_I_asin(double *x)
{
    return asin(*x);
}

double
_I_acos(double *x)
{
    return acos(*x);
}

double
_I_atan(double *x)
{
    return atan(*x);
}

double
_I_sinh(double *x)
{
    return sinh(*x);
}

double
_I_cosh(double *x)
{
    return cosh(*x);
}

double
_I_tanh(double *x)
{
    return tanh(*x);
}

double
_I_exp(double *x)
{
    return exp(*x);
}

double
_I_log(double *x)
{
    return log(*x);
}

double
_I_log10(double *x)
{
    return log10(*x);
}

double
_I_sqrt(double *x)
{
    return sqrt(*x);
}

double
_I_floor(double *x)
{
    return floor(*x);
}

double
_I_ceil(double *x)
{
    return ceil(*x);
}

double
_I_fabs(double *x)
{
    return fabs(*x);
}

double
_I_deg(double *x)
{
    return deg(*x);
}

double
_I_rad(double *x)
{
    return rad(*x);
}

dcomplex
_I_dCsin_c(dcomplex *x)
{
    return dCsin_c(*x);
}

dcomplex
_I_dCcos_c(dcomplex *x)
{
    return dCcos_c(*x);
}

dcomplex
_I_dCtan_c(dcomplex *x)
{
    return dCtan_c(*x);
}

dcomplex
_I_dCsinh_c(dcomplex *x)
{
    return dCsinh_c(*x);
}

dcomplex
_I_dCcosh_c(dcomplex *x)
{
    return dCcosh_c(*x);
}

dcomplex
_I_dCtanh_c(dcomplex *x)
{
    return dCtanh_c(*x);
}

dcomplex
_I_dCexp_c(dcomplex *x)
{
    return dCexp_c(*x);
}

dcomplex
_I_dClog_c(dcomplex *x)
{
    return dClog_c(*x);
}

dcomplex
_I_xdCsqrt(dcomplex *x)
{
    return xdCsqrt(*x);
}

dcomplex
_I_CdCabs(dcomplex *x)
{
    return CdCabs(*x);
}

